| Home | Libraries | People | FAQ | More

#### connect (4 of 8 overloads)

Establishes a socket connection by trying each endpoint in a sequence.

    template<
        typename Protocol,
        typename SocketService,
        typename Iterator>
    Iterator connect(
        basic_socket< Protocol, SocketService > & s,
        Iterator begin,
        Iterator end,
        boost::system::error_code & ec);

This function attempts to connect a socket to one of a sequence of endpoints. It does this by repeated calls to the socket's `connect` member function, once for each endpoint in the sequence, until a connection is successfully established.

###### Parameters

s

  The socket to be connected. If the socket is already open, it will be closed.

begin

  An iterator pointing to the start of a sequence of endpoints.

end

  An iterator pointing to the end of a sequence of endpoints.

ec

  Set to indicate what error occurred, if any. If the sequence is empty, set to `boost::asio::error::not_found`. Otherwise, contains the error from the last connection attempt.

###### Return Value

On success, an iterator denoting the successfully connected endpoint. Otherwise, the end iterator.

###### Example

    tcp::resolver r(io_service);
    tcp::resolver::query q("host", "service");
    tcp::resolver::iterator i = r.resolve(q), end;
    tcp::socket s(io_service);
    boost::system::error_code ec;
    boost::asio::connect(s, i, end, ec);
    if (ec)
    {
      // An error occurred.
    }